apiVersion: apps/v1
kind: Deployment
metadata:
  name: ${APP_NAME}
  namespace: ${KUBE_NAMESPACE}
  annotations:
    deployer: "${GITLAB_USER_NAME} ${GITLAB_USER_EMAIL}"
    project_url: "${CI_PROJECT_URL}"
    description: "Deployment ${APP_NAME}"
    changelog: "${CI_COMMIT_TITLE}"
    app.gitlab.com/app: ${CI_PROJECT_PATH_SLUG}
    app.gitlab.com/env: ${CI_ENVIRONMENT_SLUG}
spec:
  replicas: 1
  selector:
    matchLabels:
      app: ${APP_NAME}
  revisionHistoryLimit: 3
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 0
  template:
    metadata:
      labels:
        app: ${APP_NAME}
      annotations:
        deployer: "${GITLAB_USER_NAME} ${GITLAB_USER_EMAIL}"
        project_url: "${CI_PROJECT_URL}"
        description: "Deployment ${APP_NAME}"
        changelog: "${CI_COMMIT_TITLE}"
        app.gitlab.com/app: ${CI_PROJECT_PATH_SLUG}
        app.gitlab.com/env: ${CI_ENVIRONMENT_SLUG}
    spec:
      serviceAccountName: ${KUBE_NAMESPACE}
      automountServiceAccountToken: true
      affinity:
        podAntiAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
            - topologyKey: topology.kubernetes.io/zone
          preferredDuringSchedulingIgnoredDuringExecution:
            - podAffinityTerm:
                topologyKey: kubernetes.io/hostname
              weight: 100
      nodeSelector:
        ${SELECTOR_ROLE}
      containers:
        - name: ${APP_NAME}
          image: ${CI_REGISTRY_IMAGE}:${TAG}
          imagePullPolicy: IfNotPresent
          ports:
            - containerPort: 8080 
              name: http
              protocol: TCP
          env:
            - name: STORE
              value: ${STORE}
            - name: ENVIRONMENT
              value: ${ENVIRONMENT}
            - name: API_KEY_AWS
              value: ${API_KEY_AWS}
            - name: APP_PORT
              value: "${APP_PORT}"
            - name: NEW_RELIC_APP_NAME
              value: ${APP_NAME}-${ENVIRONMENT}
          livenessProbe:
            httpGet:
              path: /health
              port: 8080
            initialDelaySeconds: 70
            timeoutSeconds: 10
            periodSeconds: 30
          readinessProbe:
            httpGet:
              path: /health
              port: 8080
            initialDelaySeconds: 45
            timeoutSeconds: 10
            periodSeconds: 30
          resources:
            requests:
              memory: 500Mi
              cpu: '0.5'
            limits:
              memory: 1500Mi
              cpu: '1.0'
      imagePullSecrets:
        - name: gitlab-registry-credentials
